"""
Installation of GUM2DFT in Python path
see README.txt for instructions
"""

import os

from setuptools import setup


def read(fname):
    return open(os.path.join(os.path.dirname(__file__), fname)).read()


setup(
    name="GUM2DFT",
    version="0.0.96",
    author=u"Sascha Eichstädt, Björn Ludwig (PTB)",
    author_email="sascha.eichstaedt@ptb.de",
    description=(
        "A software tool for uncertainty evaluation of transient signals in the "
        "frequency domain"
    ),
    license="LGPLv3",
    keywords="uncertainty fft deconvolution",
    py_modules=["GUM2DFT"],
    packages=["doc", "examples"],
    install_requires=["numpy", "scipy", "matplotlib", "statsmodels", "notebook"],
    extras_require={
        "dev": [
            "black",
            "pytest",
            "pytest-cov",
            "hypothesis",
            "sphinx",
            "rst2pdf",
            "nbsphinx",
        ]
    },
    long_description=read("README.txt"),
    classifiers=[
        "Programming Language :: Python :: 3.8",
        "Development Status :: 4 - Beta",
        "Topic :: Utilities",
        "Topic :: Scientific/Engineering",
        "Topic :: Software Development :: Libraries :: Python Modules",
        "Intended Audience :: Education",
        "Intended Audience :: Science/Research",
        "License :: OSI Approved :: GNU Lesser General Public License v3 (LGPLv3)",
    ],
)
