from matplotlib import pyplot

from examples.example_deconvolution import deconvolution_example
from examples.example_deconvolution_MonteCarlo import (
    example_deconvolution_with_MonteCarlo,
)
from examples.example_DFT2AmpPhase import demonstrate_GUM_dft2ampphase
from examples.example_multiplication import demonstrate_multiplication
from examples.example_simulation import demonstrate_simulation
from examples.example_windowing import demonstrate_windowing


def test_deconvolution_example(monkeypatch):
    """Test executability of the deconvolution example."""
    # With this expression we override the matplotlib.pyplot.show method with a
    # lambda expression returning None but only for this one test.
    monkeypatch.setattr(pyplot, "show", lambda: None, raising=True)
    deconvolution_example()


def test_deconvolution_with_monte_carlo_example(monkeypatch):
    """Test executability of the deconvolution Monte Carlo example."""
    # With this expression we override the matplotlib.pyplot.show method with a
    # lambda expression returning None but only for this one test.
    monkeypatch.setattr(pyplot, "show", lambda: None, raising=True)
    example_deconvolution_with_MonteCarlo()
    demonstrate_windowing()


def test_dft2ampphase_example(monkeypatch):
    """Test executability of the GUM DFT to amplitude and phase example."""
    # With this expression we override the matplotlib.pyplot.show method with a
    # lambda expression returning None but only for this one test.
    monkeypatch.setattr(pyplot, "show", lambda: None, raising=True)
    demonstrate_GUM_dft2ampphase()


def test_multiplication_example(monkeypatch):
    """Test executability of the GUM_multiply example."""
    # With this expression we override the matplotlib.pyplot.show method with a
    # lambda expression returning None but only for this one test.
    monkeypatch.setattr(pyplot, "show", lambda: None, raising=True)
    demonstrate_multiplication()


def test_windowing_example(monkeypatch):
    """Test executability of the windowing example."""
    # With this expression we override the matplotlib.pyplot.show method with a
    # lambda expression returning None but only for this one test.
    monkeypatch.setattr(pyplot, "show", lambda: None, raising=True)
    demonstrate_windowing()


def test_simulation_example(monkeypatch):
    """Test executability of the simultation example."""
    # With this expression we override the matplotlib.pyplot.show method with a
    # lambda expression returning None but only for this one test.
    monkeypatch.setattr(pyplot.Figure, "show", lambda _: None, raising=True)
    demonstrate_simulation()
